SystemOrganization addCategory: #'Seaside-Welcome'!

WATask subclass: #WAWelcomeComponentCreator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Welcome'!

!WAWelcomeComponentCreator methodsFor: 'tasks' stamp: 'NickAger 11/6/2010 18:11'!
checkAuthorInitials
	GRPlatform current seasideIsAuthorNameSet ifFalse: [ self call: WAWelcomeAuthorNamePrompter new ] 
	
! !

!WAWelcomeComponentCreator methodsFor: 'tasks' stamp: 'NickAger 6/15/2010 19:53'!
chooseComponentName
	^ self call: WAWelcomeComponentNamePrompter new 
	
! !

!WAWelcomeComponentCreator methodsFor: 'tasks' stamp: 'NickAger 11/6/2010 18:18'!
createComponent: componentName
	| userComponent  |
	
	Smalltalk globals at: componentName ifPresent: [:class | self inform: 'Sorry a component named: ''',componentName, ''' already exists, please choose a different name.'. ^ nil].
	componentName first isLetter ifFalse: [ self inform: '''',componentName, ''' is not a valid name for a component. Component names should begin with a letter. Please choose again.'. ^ nil ].
	
	userComponent := WAComponent subclass: componentName instanceVariableNames: '' classVariableNames: '' poolDictionaries: '' category: 'Seaside-User-Examples'.
	userComponent isNil ifTrue: [ self inform: 'A problem occurred creating ''',componentName, ''' component..'. ^ nil ].
	
	GRPlatform current 
		compile: self sampleComponentRenderMethod
		into: userComponent
		classified: #rendering.
	
	WAAdmin register: userComponent asApplicationAt: componentName.	
		
	^ userComponent new

	
! !

!WAWelcomeComponentCreator methodsFor: 'tasks' stamp: 'jf 6/30/2010 23:50'!
displayComponent: component named: componentName
	self call: (WAWelcomeComponentConfirmation component: component named: componentName)




	
! !

!WAWelcomeComponentCreator methodsFor: 'running' stamp: 'NickAger 11/6/2010 18:11'!
go
	| componentName component |
	
	[
		[
			componentName := self chooseComponentName.
			self checkAuthorInitials.
   			component := self createComponent: componentName.
		
			component isNil
		] whileTrue.

	    	self displayComponent: component named: componentName
	] repeat
	
! !

!WAWelcomeComponentCreator methodsFor: 'private' stamp: 'lr 9/12/2010 12:01'!
sampleComponentRenderMethod
	^ 'renderContentOn: html
	html image url: ''http://www.seaside.st/styles/logo-plain.png''.
	html paragraph: ''Hello World from Seaside.''.
	html paragraph: [ 
		html text: ''To learn more about Seaside components follow the link to the book: ''.
		html anchor
			url: ''http://book.seaside.st/book/fundamentals/rendering-components'';
			with: ''Dynamic Web Development with Seaside''.
		html text: ''.'' ]'! !

!GRPackage class methodsFor: '*seaside-welcome' stamp: 'DaleHenrichs 7/27/2010 13:57'!
seasideWelcome
	^ self new
		name: 'Seaside-Welcome';
		description: 'A welcome screen for new users.';
		addDependency: 'Seaside-Environment';
		addDependency: 'Seaside-Tools-Web';
		addDependency: 'Seaside-Widgets';
		addDependency: 'Seaside-Examples';
		addDependency: 'Seaside-Development';
		addDependency: 'JQuery-Core';
		addDependency: 'JQuery-UI';
		addDependency: 'Seaside-Flow'; "For #call: - Ideally to be removed"
		addDependency: 'Seaside-Tests-Flow'; "For WAFlowConvenienceFunctionalTest - Ideally to be removed"
		url: #seasideUrl;
		yourself! !

!GRPlatform methodsFor: '*seaside-welcome' stamp: 'NickAger 11/6/2010 16:29'!
seasideIsAuthorNameSet
	self subclassResponsibility! !

!GRPlatform methodsFor: '*seaside-welcome' stamp: 'NickAger 11/6/2010 16:32'!
seasideSetAuthorName: anAuthorName
	self subclassResponsibility! !

WAFileLibrary subclass: #WAWelcomeFiles
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Welcome'!

!WAWelcomeFiles commentStamp: '<historical>' prior: 0!
A WAFileLibrary derived class for the WAWelcome* classes
!

!WAWelcomeFiles methodsFor: 'accessing' stamp: 'DaleHenrichs 7/23/2010 16:40'!
backgroundJpg
	^ #(255 216 255 224 0 16 74 70 73 70 0 1 1 1 0 72 0 72 0 0 255 254 0 28 67 114 101 97 116 101 100 32 119 105 116 104 32 71 73 77 80 32 111 110 32 97 32 77 97 99 255 219 0 67 0 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 255 219 0 67 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 1 255 192 0 17 8 0 10 3 138 3 1 34 0 2 17 1 3 17 1 255 196 0 25 0 1 0 3 1 1 0 0 0 0 0 0 0 0 0 0 0 0 6 7 8 5 10 255 196 0 29 16 1 0 1 4 3 1 0 0 0 0 0 0 0 0 0 0 0 6 4 7 54 118 5 53 181 183 255 196 0 23 1 1 1 1 1 0 0 0 0 0 0 0 0 0 0 0 0 0 6 4 5 255 196 0 32 17 1 0 1 2 6 3 0 0 0 0 0 0 0 0 0 0 0 1 3 4 5 51 52 114 115 178 2 193 194 255 218 0 12 3 1 0 2 17 3 17 0 63 0 247 139 23 239 46 62 231 67 243 200 26 102 134 69 251 203 143 185 208 252 242 6 153 128 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 10 114 226 101 208 253 114 111 233 192 215 26 156 184 153 116 63 92 155 250 112 54 171 45 93 191 36 123 100 191 210 87 217 245 14 16 10 228 144 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2 57 49 196 101 58 231 57 230 85 53 27 46 76 113 25 78 185 206 121 149 77 70 224 99 57 148 54 121 246 133 6 15 149 91 146 58 195 255 217) asByteArray! !

!WAWelcomeFiles methodsFor: 'accessing' stamp: 'NickAger 6/15/2010 20:38'!
seasidestarPng
	^ #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 60 0 0 0 64 8 2 0 0 0 201 126 131 159 0 0 23 92 105 67 67 80 73 67 67 32 80 114 111 102 105 108 101 0 0 120 1 213 89 103 88 20 75 179 238 217 188 11 75 88 114 94 114 206 105 1 201 57 231 40 2 75 206 57 163 162 8 40 65 64 68 64 64 68 80 64 84 16 16 204 32 193 128 32 73 4 21 68 162 130 160 34 2 138 137 59 232 57 231 251 238 243 221 251 239 254 185 243 60 211 243 78 85 117 117 205 84 247 84 87 13 0 28 171 212 200 200 80 4 3 0 97 225 177 209 118 198 122 100 23 87 55 50 246 37 64 1 12 64 3 110 64 160 250 196 68 234 218 216 88 128 255 245 216 26 7 208 46 243 169 244 174 174 255 85 236 127 102 48 250 250 197 248 0 0 217 192 108 111 223 24 159 48 24 95 3 0 161 231 19 25 29 11 0 242 43 76 31 78 136 141 132 49 234 17 140 153 163 97 3 97 60 181 139 3 254 224 181 93 236 253 27 163 81 191 101 28 236 244 1 64 179 3 128 163 165 82 163 3 0 32 10 193 116 114 188 79 0 172 135 104 0 0 134 20 238 27 20 14 0 147 11 140 181 124 2 169 190 0 112 148 194 50 82 97 97 17 187 184 23 198 98 222 255 166 39 224 223 48 149 234 253 143 78 42 53 224 31 252 231 89 224 158 240 192 6 65 49 145 161 212 164 223 55 255 151 77 88 104 28 252 190 126 31 36 184 165 13 15 181 218 245 13 43 124 46 249 82 13 204 225 43 55 124 254 138 12 253 237 51 88 6 226 244 11 119 180 135 105 187 88 42 220 219 202 250 47 172 229 31 109 100 7 99 184 47 100 19 25 171 183 139 225 119 6 249 71 198 218 56 252 69 63 152 28 168 111 5 99 90 152 94 228 23 99 248 183 158 170 96 170 217 174 207 232 96 122 75 116 156 157 35 140 133 96 124 47 38 222 222 16 198 240 140 130 22 146 3 29 156 255 146 217 240 245 51 248 139 142 64 248 7 25 153 254 145 65 144 130 98 77 119 199 98 134 125 46 16 18 97 190 107 3 60 22 66 5 152 131 80 224 7 226 64 52 220 134 3 105 96 1 244 129 193 95 173 52 240 7 84 152 19 15 243 98 64 8 120 3 227 48 184 71 4 220 39 2 198 228 191 228 244 255 131 98 244 187 95 0 220 239 191 107 36 3 31 88 54 238 159 49 255 140 70 134 199 252 91 103 16 240 133 241 223 116 42 60 198 46 111 215 186 24 207 160 180 127 141 249 183 196 174 190 223 214 200 93 146 91 150 251 241 183 77 40 17 148 2 74 25 165 135 210 68 105 161 212 0 25 197 138 226 4 210 40 37 20 5 165 139 210 70 105 192 60 53 96 4 22 96 205 1 127 219 184 171 63 172 197 63 190 52 34 73 221 41 16 230 238 62 187 247 223 92 224 244 91 58 232 159 251 255 176 0 4 13 174 94 95 253 219 2 0 98 253 18 225 117 0 128 126 68 100 82 116 80 64 96 44 89 23 94 185 126 82 100 211 112 31 25 41 178 130 156 188 220 46 251 255 205 177 251 205 250 99 236 103 187 223 223 34 136 117 232 95 180 232 45 0 52 158 194 243 113 244 95 52 143 10 0 90 74 0 160 255 250 47 154 176 1 0 140 197 0 116 121 251 196 69 199 255 209 135 218 189 160 1 1 208 195 51 148 3 240 2 65 32 6 191 103 5 160 2 52 128 14 48 4 102 192 26 56 0 87 224 1 207 159 64 120 14 70 131 4 176 31 28 6 153 32 7 20 128 83 160 12 156 5 53 160 30 92 1 45 224 58 184 3 186 192 3 208 15 134 193 51 48 9 102 192 34 88 1 107 96 11 124 135 32 8 11 17 33 38 136 3 226 131 132 33 73 72 1 162 64 90 144 33 100 1 217 65 174 144 23 20 0 133 67 113 208 126 232 8 148 3 21 66 101 208 57 232 34 212 12 221 132 186 160 62 104 4 122 1 205 66 203 208 58 244 13 129 68 208 34 152 17 60 8 17 132 44 130 130 208 69 152 35 28 16 251 16 1 136 40 68 50 34 29 145 135 40 69 84 35 46 35 218 17 93 136 126 196 51 196 12 98 5 177 137 4 72 26 36 43 146 31 41 141 164 32 245 145 214 72 55 164 63 50 26 121 16 153 141 44 70 86 35 27 145 183 144 15 145 79 145 51 200 85 228 54 10 131 98 66 145 81 210 240 60 53 65 57 162 124 80 81 168 131 168 92 84 25 170 30 213 142 234 69 61 69 205 162 214 80 191 208 68 52 55 90 18 173 142 54 69 187 160 3 208 9 232 76 116 49 186 22 221 134 190 143 126 134 94 68 111 97 48 24 86 140 40 70 21 99 130 113 197 4 99 82 48 185 152 51 152 38 204 61 204 8 102 30 179 137 197 98 57 176 146 88 77 172 53 150 138 141 197 102 98 79 99 47 99 59 177 163 216 69 236 87 28 13 142 15 167 128 51 194 185 225 194 113 105 184 98 92 3 174 3 55 138 123 139 251 142 103 192 11 227 213 241 214 120 95 124 18 62 31 127 30 127 11 63 132 95 196 127 39 48 18 68 9 154 4 7 66 48 225 48 161 148 208 72 184 79 152 34 124 166 161 161 17 160 81 163 177 165 9 162 57 68 83 74 115 149 230 17 205 44 205 54 45 137 86 130 86 159 214 157 54 142 54 143 182 142 246 30 237 11 218 207 68 34 81 132 168 67 116 35 198 18 243 136 23 137 61 196 105 226 87 58 38 58 25 58 83 58 95 186 84 186 114 186 118 186 81 186 15 244 120 122 97 122 93 122 15 250 100 250 98 250 86 250 33 250 85 6 60 131 8 131 62 3 149 225 32 67 57 195 77 134 9 134 77 70 38 70 121 70 107 198 48 198 92 198 6 198 62 198 37 18 150 36 66 50 36 249 146 210 73 53 164 30 210 60 19 146 73 144 73 159 201 135 233 8 211 121 166 251 76 139 204 24 102 81 102 83 230 96 230 28 230 43 204 131 204 107 44 36 22 37 22 39 150 68 150 114 150 187 44 51 172 72 86 17 86 83 214 80 214 124 214 22 214 113 214 111 108 60 108 186 108 126 108 89 108 141 108 163 108 95 216 185 216 117 216 253 216 179 217 155 216 159 177 127 227 32 115 24 114 132 112 156 224 184 206 241 138 19 197 41 193 105 203 153 192 89 201 121 159 115 149 139 153 75 131 203 135 43 155 171 133 235 37 55 130 91 130 219 142 59 133 187 134 123 128 123 147 135 151 199 152 39 146 231 52 79 15 207 42 47 43 175 14 111 48 111 17 111 7 239 50 31 19 159 22 95 16 95 17 95 39 223 59 50 11 89 151 28 74 46 37 247 146 215 248 185 249 77 248 227 248 207 241 15 242 127 23 16 21 112 20 72 19 104 18 120 37 72 16 164 8 250 11 22 9 118 11 174 9 241 9 89 10 237 23 186 36 244 82 24 47 76 17 14 20 46 17 126 40 252 69 68 84 196 89 228 168 200 117 145 37 81 118 81 83 209 100 209 75 162 83 98 68 49 109 177 40 177 106 177 49 113 140 56 69 60 68 252 140 248 176 4 66 66 89 34 80 162 92 98 72 18 33 169 34 25 36 121 70 114 68 10 45 165 38 21 46 85 45 53 33 77 43 173 43 29 47 125 73 122 86 134 85 198 66 38 77 230 186 204 7 89 33 89 55 217 19 178 15 101 127 201 41 203 133 202 157 151 155 148 39 201 155 201 167 201 223 146 95 87 144 80 240 81 40 87 24 83 36 42 26 41 166 42 222 80 252 164 36 169 228 167 84 169 244 92 153 73 217 82 249 168 114 183 242 79 21 85 149 104 149 70 149 101 85 33 85 47 213 10 213 9 10 51 197 134 146 75 121 164 134 86 211 83 75 85 187 163 182 173 174 162 30 171 222 162 254 81 67 90 35 68 163 65 99 105 143 232 30 191 61 231 247 204 107 10 104 82 53 207 105 206 104 145 181 188 180 170 180 102 180 249 181 169 218 213 218 115 58 130 58 190 58 181 58 111 117 197 117 131 117 47 235 126 208 147 211 139 214 107 211 251 162 175 174 127 64 255 158 1 210 192 216 32 219 96 208 144 100 232 104 88 102 56 109 36 96 20 96 116 201 104 205 88 217 56 197 248 158 9 218 196 220 228 132 201 132 41 143 169 143 233 69 211 53 51 85 179 3 102 189 230 180 230 246 230 101 230 115 22 18 22 209 22 183 44 17 150 102 150 39 45 167 172 132 173 194 173 174 91 3 107 83 235 147 214 175 108 68 109 162 108 110 219 98 108 109 108 203 109 223 216 201 219 237 183 123 104 207 100 239 105 223 96 191 229 160 231 144 239 48 233 40 230 24 231 216 237 68 239 228 238 116 209 233 139 179 129 115 161 243 140 139 172 203 1 151 126 87 78 215 32 215 27 110 88 55 39 183 90 183 205 189 134 123 79 237 93 116 87 118 207 116 31 223 39 186 47 113 95 159 7 167 71 168 199 93 79 122 79 170 103 171 23 218 203 217 171 193 235 7 213 154 90 77 221 244 54 245 174 240 94 243 209 247 41 241 89 241 213 241 45 242 93 246 211 244 43 244 123 235 175 233 95 232 191 20 160 25 112 50 96 57 80 59 176 56 112 53 72 63 168 44 232 83 176 73 240 217 224 47 33 214 33 117 33 59 161 206 161 77 97 184 48 175 176 155 225 164 240 144 240 222 8 222 136 196 136 145 72 201 200 204 200 153 40 245 168 83 81 107 209 230 209 181 49 80 204 190 152 27 177 204 240 230 112 32 78 44 46 35 110 54 94 43 190 60 254 107 130 83 66 107 34 99 98 120 226 64 146 68 82 86 210 219 100 163 228 11 41 168 20 159 148 238 253 252 251 15 239 159 61 160 123 224 220 65 232 160 247 193 238 84 193 212 244 212 197 67 198 135 234 15 19 14 135 28 126 146 38 151 86 152 182 113 196 249 200 173 116 158 244 67 233 243 25 198 25 151 50 233 50 163 51 39 142 106 28 61 123 12 117 44 232 216 96 150 98 214 233 172 95 217 190 217 143 115 228 114 138 115 126 228 250 228 62 62 46 127 188 244 248 78 158 127 222 96 190 74 126 101 1 166 32 188 96 252 132 246 137 250 66 198 194 228 194 249 147 150 39 219 139 200 69 217 69 27 167 60 79 245 21 43 21 159 45 33 148 196 149 204 148 90 148 222 56 45 116 186 224 244 143 178 192 178 103 229 122 229 77 21 220 21 89 21 95 206 248 158 25 173 212 169 108 60 203 115 54 231 236 183 170 160 170 231 231 140 207 181 87 139 84 23 215 96 106 226 107 222 156 119 58 255 240 2 229 194 197 90 206 218 156 218 159 117 225 117 51 245 118 245 189 23 85 47 94 108 224 110 200 191 132 184 20 119 105 249 178 251 229 225 43 6 87 110 52 74 55 158 107 98 109 202 185 10 174 198 93 125 215 236 213 60 222 98 222 210 221 74 105 109 188 38 124 173 162 141 169 45 187 29 106 79 106 95 187 30 120 125 230 134 235 141 145 155 102 55 187 111 105 220 106 187 45 115 187 238 14 255 157 242 187 44 119 243 59 8 29 233 29 59 157 201 157 155 247 34 239 173 118 5 116 205 119 123 118 79 246 184 244 140 245 218 246 14 222 55 191 255 232 129 209 131 158 135 186 15 59 31 105 62 186 211 167 222 119 243 49 229 241 245 126 149 254 246 1 229 129 182 39 202 79 218 6 85 6 219 135 84 135 110 12 171 13 223 26 217 51 210 49 170 61 218 245 212 224 233 131 49 211 177 254 103 86 207 70 198 29 199 159 79 184 79 204 60 247 125 190 244 34 244 197 167 151 241 47 191 79 30 154 66 79 101 191 98 120 85 60 205 61 93 253 90 252 117 211 140 202 204 221 89 131 217 129 57 251 185 201 121 159 249 149 133 152 133 31 139 233 111 136 111 138 223 242 189 189 184 164 176 116 103 217 104 121 248 221 222 119 139 43 145 43 223 87 51 223 51 190 175 248 32 246 225 218 71 157 143 3 107 46 107 139 159 162 63 237 172 231 126 230 248 92 183 161 180 209 189 105 179 57 189 21 182 245 253 75 246 87 142 175 245 219 148 237 135 223 156 191 189 253 158 240 3 251 163 244 167 248 207 91 191 204 127 77 237 132 237 236 68 82 163 169 191 247 2 72 184 69 248 251 3 176 94 7 231 16 174 112 238 48 12 0 225 222 159 156 226 183 4 156 174 64 176 12 140 37 65 47 36 14 197 67 211 112 4 190 136 36 35 203 81 130 168 203 104 29 244 20 38 23 107 10 199 176 69 124 39 225 10 205 101 218 54 98 15 221 43 6 12 163 34 41 130 169 141 249 7 171 17 219 25 246 45 78 27 174 75 60 24 94 15 190 86 126 162 128 159 224 53 97 180 136 139 104 181 216 59 9 138 228 126 169 78 25 32 171 47 151 33 223 163 136 84 210 87 78 87 185 163 186 161 38 169 238 166 81 176 167 87 115 75 91 84 199 89 55 83 175 69 127 202 16 101 36 110 108 106 226 111 154 106 118 202 252 146 197 93 203 65 171 41 235 15 182 180 118 10 246 142 14 137 142 101 78 183 157 95 186 124 115 227 217 187 199 221 117 95 172 71 129 103 131 87 15 117 202 251 179 47 141 159 144 191 90 128 89 160 99 144 87 112 112 72 100 104 114 216 161 240 35 17 71 35 143 69 101 68 167 199 236 143 141 137 11 142 247 74 176 75 212 79 82 76 102 79 254 148 210 187 191 228 64 248 65 163 84 254 67 224 208 252 225 190 180 150 35 85 233 39 50 50 50 147 142 198 28 11 207 10 201 142 200 57 153 251 46 79 61 255 88 193 104 33 251 73 215 162 211 167 70 75 176 165 106 167 253 203 242 202 111 85 76 87 34 207 138 86 89 157 139 175 174 168 233 58 63 95 139 171 147 172 183 186 24 217 80 120 169 229 242 224 149 213 38 252 85 145 102 157 150 189 173 113 215 242 219 46 182 63 184 62 119 99 231 22 231 109 229 59 150 119 169 29 177 157 25 247 138 187 46 116 55 246 220 234 125 112 127 236 193 171 135 139 143 222 247 45 62 126 222 127 127 160 229 73 217 224 193 33 143 97 141 17 150 145 143 163 61 79 79 143 133 63 211 25 39 141 47 76 52 62 143 121 161 244 98 227 101 211 164 255 20 215 212 208 171 195 211 10 211 11 175 139 103 204 103 145 179 183 231 226 231 85 23 192 194 147 197 146 55 94 111 197 222 126 92 106 89 142 122 39 243 238 221 74 245 170 235 123 226 251 142 15 145 31 5 63 78 173 157 253 20 180 174 254 153 244 121 99 99 110 115 114 107 238 203 230 54 243 55 237 239 49 63 174 254 92 223 17 222 217 129 253 207 3 142 64 140 144 51 116 29 193 139 136 71 204 32 45 144 93 240 142 127 8 237 131 65 96 26 177 254 56 81 220 26 126 144 208 70 83 79 91 69 172 161 107 165 127 194 176 65 226 96 50 97 78 98 105 102 93 102 23 227 240 230 172 230 122 201 195 198 235 192 119 148 124 151 255 147 160 176 144 181 112 138 200 121 209 126 177 247 18 12 146 242 82 246 210 145 50 199 101 175 200 61 146 159 81 248 170 68 175 44 160 162 174 106 73 241 81 139 85 63 162 113 114 79 181 102 163 214 13 237 78 157 30 221 251 122 61 112 92 185 99 216 102 116 217 184 218 164 194 180 198 172 217 188 211 226 177 229 184 213 172 245 138 205 134 29 176 167 113 32 57 114 58 9 56 139 186 200 184 42 186 81 246 106 185 27 238 51 241 48 246 212 241 162 80 229 188 69 125 248 124 89 253 136 254 40 255 237 128 143 129 11 65 207 131 7 66 186 66 175 135 53 132 87 70 228 71 38 70 25 69 19 163 199 98 42 99 67 227 40 241 216 248 151 9 77 137 153 73 251 146 85 82 24 83 86 247 63 62 208 112 48 43 53 240 144 227 97 231 52 234 145 176 244 248 140 212 204 163 71 79 30 171 204 170 203 190 154 115 39 247 225 241 145 188 87 249 75 5 159 11 193 73 134 34 254 83 10 197 186 37 246 165 254 167 227 203 50 202 139 43 106 207 92 171 236 60 59 80 53 126 110 182 122 185 230 227 249 237 90 66 157 120 189 197 197 168 134 178 75 93 151 223 53 50 52 105 94 13 110 46 105 121 208 250 165 77 172 221 253 122 254 141 174 155 27 183 201 119 244 239 250 118 164 119 86 220 107 234 234 234 238 239 25 236 29 134 191 78 29 15 155 31 85 247 229 63 78 233 15 24 112 124 162 55 40 53 196 60 180 61 252 98 164 109 180 224 105 200 152 193 51 158 103 95 199 159 78 180 60 47 124 17 251 210 109 82 127 74 246 21 215 52 97 250 219 235 213 153 153 217 103 115 253 243 247 23 186 22 59 222 116 188 189 179 116 119 185 227 93 231 74 207 234 147 247 139 31 49 107 74 159 162 215 239 108 176 110 30 217 250 249 53 227 27 251 247 182 159 206 191 126 253 246 191 19 196 12 249 193 171 95 9 145 129 120 139 52 66 94 70 241 160 242 208 52 232 44 12 9 115 30 171 133 157 198 101 226 41 248 45 66 59 205 33 90 123 162 52 29 145 110 157 126 142 97 136 177 135 212 197 244 132 249 21 203 71 54 20 59 59 135 24 167 14 151 29 183 31 79 2 239 81 190 83 228 243 252 173 2 157 130 125 66 79 133 95 139 44 139 174 137 125 149 0 146 56 41 156 212 142 244 39 153 215 178 195 114 247 228 155 20 206 40 102 41 197 41 123 168 24 169 74 82 232 41 31 213 70 212 27 53 178 246 248 106 106 107 113 104 173 105 247 233 212 232 166 234 121 234 107 27 240 26 34 12 23 140 30 26 55 152 28 55 141 54 115 52 215 176 224 177 4 150 115 86 221 214 53 54 233 182 254 118 86 246 26 14 66 142 180 142 31 157 6 157 27 92 210 93 93 220 36 220 126 236 29 112 47 223 23 228 161 238 73 227 249 202 171 153 154 237 237 231 35 225 179 232 123 198 207 213 159 211 255 117 64 67 96 82 144 101 176 112 8 20 242 42 244 118 216 233 240 216 8 171 72 209 200 159 81 253 209 5 49 246 177 108 177 47 227 42 226 247 37 144 19 230 18 107 146 124 146 133 147 223 164 212 238 15 56 32 122 96 233 96 67 106 204 33 171 195 114 105 140 105 155 71 94 166 119 100 84 195 243 36 244 152 77 150 66 54 115 246 86 206 120 238 181 227 39 242 34 242 109 11 148 79 240 22 210 20 126 59 249 190 104 238 212 68 241 88 201 88 233 179 211 47 202 102 202 151 43 54 207 236 156 197 87 113 159 211 174 14 175 57 115 126 176 22 170 83 170 15 184 88 222 208 119 105 253 10 107 163 74 147 205 85 223 230 216 150 195 173 121 215 106 218 58 218 199 175 175 222 4 183 72 183 5 238 40 221 53 237 240 238 60 124 175 182 107 172 135 208 107 124 255 248 131 241 71 52 125 202 143 61 251 115 7 238 60 89 27 18 31 166 142 84 141 78 143 241 62 115 31 175 152 120 249 130 253 165 203 228 185 169 173 105 215 215 195 179 238 243 184 133 231 111 198 150 241 43 177 31 72 107 111 63 207 127 225 249 22 241 243 245 174 255 255 212 150 118 99 2 70 5 128 11 140 0 56 193 57 168 213 37 0 170 34 0 16 134 235 53 12 112 189 196 134 8 128 131 26 64 196 117 3 4 237 0 128 114 7 254 137 31 8 64 132 115 77 5 96 10 103 249 201 160 8 206 30 31 129 57 240 3 98 131 20 33 107 40 4 58 6 93 128 186 161 25 104 7 193 135 208 66 120 34 14 193 89 221 125 196 50 146 14 169 132 116 71 166 35 175 32 39 80 72 148 60 202 19 149 135 234 68 173 163 69 208 110 232 19 232 62 12 18 163 133 73 198 92 199 108 97 85 177 137 216 219 216 95 56 67 220 113 220 4 94 0 31 5 71 36 122 130 23 225 26 13 158 198 139 230 6 45 19 109 4 237 32 81 150 88 72 220 166 243 166 27 164 215 164 111 100 16 96 40 101 36 49 230 145 112 164 84 210 38 83 4 211 59 230 0 230 55 44 129 44 43 172 145 172 155 108 7 217 9 236 165 28 162 28 55 57 173 56 23 184 14 112 179 115 95 227 177 227 217 224 45 231 51 230 219 36 215 242 239 21 96 16 232 19 60 42 100 36 76 16 126 42 114 70 52 66 204 64 156 91 252 139 196 115 201 187 82 181 210 231 100 154 100 187 229 70 229 23 20 62 43 65 202 180 42 108 170 188 20 97 56 178 41 106 168 238 217 163 169 167 165 175 45 166 189 170 115 67 55 67 207 81 95 76 255 151 193 75 195 27 70 165 198 7 77 130 76 157 204 76 205 117 45 180 44 41 86 154 214 186 54 38 182 182 118 46 246 222 14 17 142 169 78 39 157 235 92 238 186 78 184 173 187 51 236 147 243 112 240 60 224 85 71 29 243 65 248 42 249 133 248 159 11 152 12 98 15 118 12 41 12 29 13 103 138 112 142 172 140 90 138 81 139 45 136 91 78 48 73 172 75 166 75 57 176 255 221 65 183 212 190 195 122 105 29 233 106 25 163 71 19 178 196 179 95 231 86 231 69 21 88 22 42 23 9 20 147 75 185 202 4 43 228 43 13 170 194 171 155 47 32 235 2 46 46 94 14 111 66 52 87 93 211 108 31 186 233 115 251 125 135 195 189 150 30 222 251 249 143 104 31 159 126 162 57 244 97 244 234 179 140 231 97 147 238 211 10 51 115 243 113 139 159 150 236 222 149 172 118 125 120 186 54 184 126 107 163 100 43 240 171 236 246 218 247 43 63 3 126 127 63 144 112 189 65 16 174 48 56 192 53 164 108 80 11 122 192 107 216 251 28 112 77 192 9 174 2 20 65 173 208 24 180 137 96 67 168 195 185 125 26 162 14 49 8 103 241 188 72 83 100 44 178 10 57 132 220 65 201 193 153 121 9 106 16 141 129 247 28 41 232 155 232 109 140 58 230 0 166 11 139 195 218 98 203 176 139 56 37 92 58 110 28 47 129 63 140 127 78 80 32 28 39 172 208 88 208 52 194 217 111 18 237 60 209 154 216 73 167 64 87 79 47 64 95 201 192 195 80 197 40 194 216 68 82 32 181 48 41 49 221 100 214 97 238 99 113 100 153 103 141 97 67 178 149 176 203 178 63 226 240 225 68 192 177 202 144 235 29 247 9 30 53 158 55 188 165 124 182 100 90 242 99 254 28 1 75 65 38 193 73 161 90 225 56 17 67 81 14 209 79 98 143 197 107 36 142 72 250 72 153 74 83 100 44 100 35 228 10 229 155 21 198 21 191 42 179 171 168 169 186 83 82 213 206 171 247 105 124 208 100 211 210 211 222 167 67 213 245 209 243 215 15 51 72 52 204 48 42 48 174 52 105 54 125 104 54 105 190 110 73 180 18 179 54 180 241 179 61 102 87 103 223 231 176 226 196 224 172 238 226 229 154 229 118 99 239 242 62 46 15 27 207 99 94 15 189 49 62 230 190 5 126 147 1 82 129 41 65 253 33 152 80 221 176 248 240 230 136 55 81 252 209 110 49 229 177 19 241 140 9 54 137 121 73 79 82 104 247 91 30 56 126 240 201 33 210 97 151 180 202 35 43 25 6 153 181 199 240 89 145 217 139 185 222 199 231 242 195 79 224 10 107 139 156 139 233 75 134 78 151 148 7 157 209 59 203 81 245 169 122 228 252 173 218 203 245 87 27 58 47 63 107 92 107 102 105 85 106 115 185 158 112 243 212 237 43 119 187 59 135 186 94 247 188 191 255 253 17 250 49 195 0 215 160 240 176 196 168 204 152 226 184 210 115 173 151 122 83 166 211 118 51 110 115 14 11 170 111 72 111 167 151 79 173 232 173 206 126 136 253 184 249 41 102 125 97 195 102 179 253 11 203 215 200 237 190 239 228 31 241 63 251 127 251 31 2 56 192 9 175 127 43 184 162 116 28 52 129 81 176 9 113 66 218 112 76 201 133 174 65 83 8 44 66 1 246 252 81 68 43 188 183 160 67 106 33 35 225 58 205 4 138 136 50 68 165 162 110 163 182 209 20 116 18 250 46 188 218 205 48 39 49 211 88 41 108 10 118 0 174 155 36 224 198 240 202 248 50 252 14 33 144 240 148 70 143 166 149 86 12 222 127 112 19 203 233 200 116 23 232 21 233 187 25 28 25 86 24 51 73 2 164 123 76 30 76 191 152 207 177 232 195 107 251 36 155 54 219 42 251 25 14 107 78 12 103 39 188 174 181 120 16 60 143 120 115 248 44 200 204 228 25 56 38 229 11 70 8 185 9 155 138 104 138 82 196 40 226 42 18 106 146 154 82 90 210 154 50 30 178 167 229 134 21 144 138 50 74 14 202 9 42 167 84 91 40 163 106 235 26 92 123 76 52 147 181 218 117 232 116 195 244 134 13 212 13 27 140 57 76 10 205 24 204 243 45 89 173 206 218 200 216 118 217 27 59 52 58 209 57 199 186 60 115 219 179 183 126 31 147 71 154 231 22 53 202 251 189 111 164 223 118 64 118 16 103 112 93 168 66 216 181 8 213 200 246 104 197 152 107 113 82 241 85 137 172 73 217 201 63 246 71 28 152 78 181 62 244 40 109 207 145 243 233 27 153 6 71 139 143 45 103 171 229 228 230 206 229 81 242 243 11 62 22 58 158 236 61 165 92 220 86 74 57 253 184 220 187 98 167 178 178 74 238 92 71 141 195 249 15 181 57 245 178 23 95 92 74 191 34 213 56 118 53 161 133 177 181 190 77 185 253 246 13 173 155 55 111 75 221 57 215 33 209 217 223 21 218 67 215 219 244 192 242 225 82 95 106 63 199 64 203 160 193 208 228 72 212 83 252 88 253 184 238 196 220 139 35 147 162 83 61 211 78 175 103 103 125 231 38 22 180 22 207 188 89 90 18 93 118 123 151 178 82 176 122 230 125 233 135 156 143 49 107 142 159 100 215 209 235 35 159 43 54 220 55 185 55 159 111 21 125 49 251 242 229 235 133 109 219 237 31 223 234 190 91 126 255 12 103 29 26 63 167 127 245 237 250 63 198 95 81 97 55 122 0 136 86 15 46 63 78 239 236 124 22 1 0 91 8 192 207 19 59 59 223 171 119 118 126 214 192 201 6 252 15 228 94 232 159 255 21 187 194 24 184 230 94 177 251 15 3 244 198 196 30 218 189 254 251 241 95 52 194 139 146 193 91 214 157 0 0 0 9 112 72 89 115 0 0 11 19 0 0 11 19 1 0 154 156 24 0 0 12 45 73 68 65 84 104 5 237 89 91 108 92 197 25 254 207 117 111 222 93 123 125 141 189 33 78 136 29 7 66 8 165 109 46 110 26 72 107 74 0 1 109 218 148 2 173 80 81 21 81 9 94 17 111 168 111 85 95 42 209 130 84 158 90 169 47 5 5 85 77 67 104 11 52 88 6 2 14 33 9 36 196 144 56 182 215 241 125 189 215 179 123 174 211 111 206 49 150 157 203 122 125 156 84 138 148 209 104 60 59 103 206 204 55 223 124 255 63 255 28 11 140 49 186 209 146 120 163 1 230 120 111 130 254 127 237 218 77 166 111 50 93 129 129 27 82 30 114 133 5 85 243 200 206 76 90 253 127 183 83 167 141 182 59 197 187 246 212 36 26 69 241 186 19 33 172 228 112 97 233 81 235 224 111 149 255 188 68 140 44 37 154 219 244 136 253 147 223 36 90 111 145 36 169 154 5 251 238 179 2 86 24 115 198 191 20 143 29 224 115 59 36 151 243 145 211 135 204 195 127 204 229 114 43 33 162 154 149 248 7 205 108 203 73 167 132 194 52 159 70 224 57 80 74 71 63 125 35 251 241 155 182 109 87 51 183 239 62 254 65 19 49 102 148 136 44 126 170 66 14 40 21 10 23 71 98 71 254 52 123 113 200 113 28 223 152 150 124 209 63 104 144 75 204 18 32 103 15 52 126 75 36 5 205 200 228 73 243 216 225 98 33 127 253 68 226 31 52 48 65 33 130 0 57 19 5 230 20 66 17 10 200 179 234 39 7 138 103 251 109 203 90 146 51 127 29 252 131 134 58 68 199 228 52 171 46 104 84 160 8 212 155 40 54 113 148 29 61 48 59 54 124 157 68 178 2 208 196 28 219 224 38 8 160 17 23 183 39 227 58 82 107 139 53 95 190 101 29 123 75 43 22 150 228 146 239 24 246 68 215 237 98 209 209 52 199 48 150 124 101 5 135 11 99 130 99 204 49 13 208 128 7 179 68 86 136 90 169 230 252 57 253 248 129 66 178 43 176 101 167 162 160 233 178 228 56 12 78 198 178 74 227 227 230 201 147 229 190 62 235 204 25 38 203 78 79 79 252 209 71 163 45 45 21 14 169 21 128 134 9 98 86 108 21 4 29 118 201 206 18 233 68 96 170 150 132 54 138 15 31 157 249 232 141 108 203 218 68 219 26 15 1 56 21 128 213 177 204 82 201 26 29 178 79 246 155 239 189 87 124 235 61 118 97 68 181 109 215 146 201 60 120 48 149 205 182 239 223 31 73 36 46 91 232 92 195 10 64 227 158 6 166 225 236 0 58 68 84 227 114 12 208 26 81 61 81 3 41 90 161 230 139 127 228 227 109 90 207 207 195 117 245 34 214 152 159 117 134 207 8 167 250 156 99 71 196 207 78 82 106 134 21 28 37 71 134 68 58 6 115 213 21 178 44 235 237 183 11 123 247 134 235 234 4 129 187 168 203 211 10 64 195 97 56 174 147 198 230 67 214 192 13 244 57 162 34 92 33 81 144 104 21 213 104 67 234 219 191 43 159 237 45 182 111 193 145 169 158 250 175 50 58 32 56 186 34 146 165 146 177 138 139 74 64 231 89 142 152 3 132 7 101 84 14 135 109 174 116 118 61 64 35 224 112 153 6 104 76 232 145 13 208 121 126 224 240 5 128 251 118 82 197 180 154 58 68 231 14 113 207 8 21 221 234 174 16 206 61 79 242 56 153 179 100 228 137 233 36 72 110 54 41 23 10 25 187 118 169 241 248 117 209 52 66 45 178 117 174 105 128 134 72 80 194 28 129 30 182 8 89 3 49 26 227 68 29 68 109 110 11 30 161 5 26 192 146 114 228 140 146 62 74 198 4 57 176 139 40 73 10 89 26 9 162 52 254 200 35 201 158 158 154 218 218 203 85 49 223 226 95 30 172 156 23 70 63 227 252 65 27 30 32 16 137 58 100 13 133 120 147 98 235 177 24 44 0 64 17 143 152 110 206 144 51 72 214 121 114 210 252 105 164 141 4 133 244 41 146 77 113 104 199 142 216 254 253 77 107 215 6 2 216 169 171 166 229 131 134 214 44 147 74 89 227 253 63 171 163 31 193 224 184 18 64 33 240 65 33 192 13 67 4 217 192 231 53 130 90 100 60 69 137 71 99 68 195 196 166 200 193 38 37 40 92 71 48 182 226 121 168 69 24 93 119 43 61 247 220 154 59 238 136 68 34 87 83 179 183 142 170 64 115 155 96 14 217 166 99 150 173 233 11 66 234 152 115 226 159 129 129 67 20 51 225 146 57 104 96 130 78 64 51 72 157 114 153 6 223 176 69 15 46 158 130 233 89 162 175 136 38 221 37 5 72 110 38 181 145 112 97 40 156 38 123 146 210 241 134 194 179 207 110 236 238 142 85 84 115 21 160 25 252 191 37 216 166 153 155 116 82 199 233 124 159 52 252 161 60 125 70 180 103 185 124 219 93 215 6 100 72 192 4 208 96 0 160 81 194 22 113 214 64 24 0 13 85 64 45 19 68 35 110 137 5 0 107 27 137 240 229 144 250 48 233 131 84 176 130 19 207 252 114 253 3 15 212 214 215 203 242 210 60 94 161 7 179 12 166 23 44 45 67 19 103 157 145 126 49 245 161 52 126 74 201 167 132 16 227 88 65 45 52 224 57 56 76 11 16 128 229 85 128 27 107 0 241 64 12 55 130 62 0 13 130 83 68 227 174 54 176 164 36 207 2 186 25 100 79 145 62 64 165 116 224 226 190 199 146 143 63 222 208 218 170 170 216 172 165 211 165 160 89 41 239 12 190 111 125 250 55 144 42 101 6 5 86 226 132 1 7 60 0 166 4 92 188 1 177 2 37 50 146 87 153 47 241 20 253 193 52 68 50 207 113 198 237 137 3 174 147 168 217 85 81 153 131 54 206 131 102 41 213 189 171 246 233 167 87 173 91 23 12 122 187 230 118 174 88 44 2 205 109 172 255 175 242 225 23 2 122 134 83 136 228 129 192 104 0 10 16 152 12 116 34 123 40 81 65 66 187 199 55 68 2 41 163 17 21 232 97 250 235 83 29 107 110 34 90 77 212 226 142 3 27 181 201 24 35 235 43 113 188 169 67 126 230 215 201 219 110 11 135 195 149 141 207 157 105 174 88 4 218 209 53 225 157 223 11 197 12 199 225 193 66 5 78 23 65 197 60 80 180 47 172 47 28 12 88 177 42 8 3 9 117 188 136 4 87 157 228 167 35 69 221 49 93 211 116 178 228 156 165 105 163 62 247 212 47 214 111 221 26 175 194 248 220 177 230 138 197 160 45 67 196 13 10 64 49 52 192 45 76 224 210 157 143 147 138 138 151 61 130 81 122 217 235 128 215 241 211 75 144 40 216 5 98 232 202 123 138 210 36 107 156 236 81 154 217 188 173 101 215 189 241 186 186 229 222 222 23 129 150 195 113 173 235 193 224 137 191 72 154 198 131 0 48 10 129 66 24 40 189 10 160 0 144 135 24 92 34 3 226 124 137 10 216 69 7 8 192 235 134 167 224 30 141 80 8 70 67 66 139 73 172 64 101 204 208 210 22 170 75 84 105 124 238 203 115 197 34 208 2 220 230 253 47 100 45 10 156 57 24 52 51 130 81 22 75 38 247 190 152 15 84 193 16 225 16 22 190 1 100 243 224 128 6 224 160 141 20 17 142 58 79 66 64 63 230 246 89 77 20 115 119 207 5 45 168 132 79 35 106 38 139 216 127 33 154 42 235 210 139 47 190 184 176 171 26 137 211 134 123 51 109 219 242 106 131 99 194 94 74 34 19 73 179 5 141 113 254 160 25 16 15 220 200 94 5 59 128 85 129 72 24 43 74 36 248 10 56 230 58 87 24 232 6 247 135 22 96 67 55 116 198 194 48 142 197 15 20 125 176 96 116 221 94 211 209 33 95 241 150 176 16 214 226 250 165 160 241 20 23 141 104 203 154 80 215 206 92 199 15 114 173 223 46 171 117 204 48 229 82 25 222 143 50 142 80 68 156 228 162 7 32 79 247 243 234 7 235 112 118 23 221 246 164 107 127 112 115 232 134 70 112 143 18 184 209 25 23 75 27 199 43 73 3 153 124 186 164 108 223 17 168 173 173 16 211 45 6 204 127 93 1 180 215 9 198 17 141 197 107 111 217 32 119 237 202 117 222 151 107 186 93 151 34 130 166 139 69 139 101 152 48 107 11 80 48 52 3 242 128 195 203 160 112 210 5 13 154 219 92 119 1 238 225 52 176 9 37 98 51 100 165 137 33 166 131 114 16 135 75 100 23 137 157 28 158 170 111 142 108 220 168 46 199 229 85 251 45 15 46 188 88 40 100 71 207 217 3 239 135 191 120 167 230 203 222 64 121 74 88 199 168 253 107 85 128 102 200 224 51 87 196 235 137 214 184 237 222 98 176 188 9 178 207 144 254 5 217 34 201 109 20 72 112 208 229 73 42 124 66 51 193 118 249 165 63 36 119 239 14 132 96 49 85 165 171 50 125 201 219 240 252 106 32 16 107 104 137 118 220 109 223 246 189 98 124 117 224 220 199 82 62 207 67 80 240 13 112 112 41 56 77 134 92 179 3 98 16 236 217 34 74 236 6 250 132 200 154 166 114 138 103 86 38 81 37 57 64 182 69 210 87 153 108 58 35 221 125 119 48 145 168 82 36 24 114 121 9 227 198 18 13 13 59 247 150 182 61 201 77 10 66 7 199 200 112 109 51 110 128 129 248 4 25 203 64 163 151 176 30 44 161 150 212 59 73 109 39 171 76 179 159 83 230 20 233 211 36 99 49 49 138 254 251 95 83 175 189 166 205 204 96 63 231 94 169 248 103 217 160 231 70 83 130 202 134 237 204 134 48 191 118 213 240 18 96 26 9 71 32 12 14 179 3 43 158 194 93 192 117 96 109 6 201 49 10 223 65 145 77 36 133 72 27 162 236 105 50 50 36 199 41 32 90 202 171 175 142 247 246 150 139 240 59 75 39 216 182 207 36 122 92 2 22 192 129 114 68 115 56 237 161 4 128 70 66 59 164 156 37 134 123 138 65 76 225 122 16 32 232 0 69 187 8 225 103 246 115 210 211 100 151 72 141 147 19 164 248 248 216 244 203 47 103 214 175 87 54 109 90 50 58 245 9 154 127 119 44 151 4 203 230 136 1 14 4 141 187 164 34 48 130 54 128 24 212 142 240 107 149 153 22 205 178 100 194 229 203 142 20 231 188 202 17 82 234 41 182 129 180 65 42 79 81 105 138 36 153 116 153 226 71 142 164 95 121 69 121 254 249 68 123 123 101 113 251 4 141 67 94 176 220 195 12 160 33 0 248 13 48 13 173 225 216 195 144 88 195 8 217 23 68 173 28 207 53 39 117 181 78 204 150 228 145 73 231 212 164 32 148 3 113 38 69 73 84 184 90 20 131 95 200 161 114 36 230 56 161 215 95 159 238 238 14 55 52 132 99 24 232 170 201 63 104 166 107 156 81 207 22 113 118 64 211 56 231 65 51 90 70 201 25 18 50 172 101 162 251 1 251 187 15 135 87 175 21 139 154 113 226 132 243 230 97 233 236 89 54 49 193 38 178 162 104 42 65 126 65 148 84 14 154 223 230 224 96 210 233 220 225 195 197 157 59 67 209 104 133 72 213 55 104 135 33 168 2 205 32 9 28 195 111 192 242 224 10 144 102 136 13 82 94 139 79 108 191 95 249 209 175 218 55 110 194 213 26 219 109 223 245 141 236 253 123 242 39 78 152 125 125 206 209 163 202 133 11 108 102 198 209 242 2 57 176 14 207 213 160 98 95 188 168 227 75 164 227 84 8 253 124 131 102 100 104 92 205 184 96 35 123 1 55 6 195 183 162 49 210 102 131 19 155 191 35 244 252 184 185 163 11 247 17 79 160 48 175 250 100 50 209 214 166 221 115 79 97 120 184 212 223 175 247 246 178 227 199 131 169 148 147 201 48 155 75 196 140 68 244 206 78 57 130 253 170 148 252 131 22 74 110 228 13 249 122 78 45 72 12 122 25 67 36 36 78 222 114 103 121 247 222 85 155 191 137 143 1 151 152 20 54 29 141 56 183 237 206 206 194 67 15 229 7 6 140 119 223 53 63 248 64 0 116 203 74 111 216 80 179 111 95 164 190 254 146 183 46 89 129 111 208 142 160 151 184 60 0 26 113 133 69 248 190 110 227 115 81 90 40 72 137 252 174 31 54 116 239 174 173 24 6 97 247 17 254 199 183 110 213 183 108 201 61 249 100 97 100 196 52 205 68 107 107 67 115 243 146 87 47 223 160 153 128 48 30 225 188 73 14 24 119 75 43 71 101 22 26 255 214 246 154 221 123 234 27 155 160 135 10 198 52 79 30 20 223 152 76 34 67 199 56 17 193 241 146 111 249 5 141 25 138 26 244 96 226 238 164 115 154 113 130 24 166 154 222 184 217 218 251 84 203 218 91 113 31 89 114 238 121 220 94 165 178 36 22 118 246 11 154 127 108 214 237 60 149 203 28 49 51 200 178 165 92 114 237 236 67 63 109 223 214 61 111 124 11 103 186 134 117 159 160 153 32 58 225 6 51 11 118 93 133 24 130 214 216 50 243 253 135 155 246 60 92 183 252 139 234 114 215 227 55 96 82 131 214 166 109 154 84 139 175 203 122 81 204 71 155 166 191 219 19 219 247 179 150 85 171 174 252 31 150 229 226 170 216 223 39 211 66 48 24 216 121 223 244 131 143 153 189 125 37 73 41 237 232 174 121 226 137 213 157 157 62 164 92 17 222 149 31 86 123 115 185 252 109 88 122 118 114 114 118 96 0 199 118 104 205 154 134 198 70 32 174 112 140 93 62 130 239 22 255 160 231 167 172 222 85 205 191 178 194 202 53 0 189 66 4 62 94 247 107 136 62 166 186 118 175 220 4 125 237 184 172 60 210 77 166 43 243 115 237 158 222 144 76 255 15 11 35 46 166 247 55 116 18 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray! !

!WAWelcomeFiles methodsFor: 'accessing' stamp: 'NickAger 6/16/2010 00:23'!
selectorsToInclude
	^ #(welcomeCss syntaxHighlightingCss)! !

!WAWelcomeFiles methodsFor: 'resources' stamp: 'NickAger 6/16/2010 00:23'!
syntaxHighlightingCss	^ '
span.patternUnary  {
color:#000000;
font-weight:bold;
}

span.patternKeyword  {
color:#000000;
font-weight:bold;
}

span.patternArg {
color:#000088;
}

span.super  {
color:#008888;
}

span.instanceVar  {
color:#000088;
}

span.number  {
color:#880088;
}

span.receiver  {
color:#000088;
}

span.keyword  {
color:#000000;
}

span.string  {
color:#880088;
}

span.blockArg  {
color:#000088;
}

span.class  {
color:#000088;
}

span.self  {
color:#008888;
}

span.symbol  {
color:#880088;
}
'! !

!WAWelcomeFiles methodsFor: 'resources' stamp: 'NickAger 8/3/2010 16:37'!
welcomeCss
	^ '* {
	line-height: 1.5;
	font-family: "Helvetica Neue", Helvetica, Verdana, Arial, sans-serif;
}
html, body {
	color: #2a2a2a;
	font-size: 14px;
	margin-top: 0px;
	background: #fff url("background.jpg") repeat-y center top;
}
input.text {
	color: #2a2a2a;
	font-size: 100%;
	border: 1px solid #ccc;
}

div.clear {
	clear: both;
}

a {
	color: #008AFF;
	text-decoration: none;
}

a.goback {
	font-size: 80%;
	color: #888888;
}

.container  {
	/* auto  margin positioning:*/
	/*margin-left: auto;
	margin-right:auto; */
	/* end auto margin positioning */
	
	/* negative margin positioning */
	position: absolute;
	left: 50%;
	margin-left: -450px;
	/* end negative margin positioning */
	
	margin-top: 0px;
	padding-bottom: 25px; /*with absolute positioning, the body margin for the toolbar does not seem to work*/
	width: 900px;
	/*border-right: 1px solid #cccccc;
	border-left: 1px solid #cccccc;*/
}

.sidebar  {
	width:200px;
	/*background-color: #E5F2FC;*/
	float: right;
	padding:25px;
	padding-top: 5px;
	/*border-left: 1px solid #CCCCCC;
	border-bottom: 1px solid #CCCCCC;*/
}

.sidebar li {
	list-style-type: none;
}	
	
.sidebar  h3 {
	border-bottom: 1px solid #cccccc;
	font-size: 150%;
	margin-top: 25px;
	padding-bottom: 10px;
}

.sidebar ul {
	margin-left: 0;
	padding-left: 0;
}

.sidebar li {
	margin-bottom: 5px;
}

.content  {
	margin-right: 260px;
	padding: 20px;
}

.header {
	background: #fff url("seasidestar.png") no-repeat left center;
}

.welcome {
	font-size: 225%;
	margin: 0;
}

.welcome, .congrats, .getting-started {
	padding-left: 75px;
	padding-right: 30px;
}

.congrats {
	color: #888888;
	font-size: 125%;
	font-weight: normal;
	margin: 0;
}

.getting-started, .back-form {
	border-top: 1px solid #cccccc;
	margin-top: 25px;
	padding-top: 15px;
}

.getting-started h1 {
	font-size: 150%;
	margin: 0;
}

.getting-started h2 {
	color: #333333;
	font-size: 125%;
	font-weight: normal;
	margin: 0 0 25px;
}

.getting-started ol {
	margin-left: 0;
	padding-left: 0;
	color: #888888;
	font-size: 125%;
}

.getting-started li {
	margin-bottom: 25px;
}

.getting-started li h3 {
	margin: 0;
	color: #333333;
	font-size: inherit;
	font-weight: normal;
}

.getting-started li p, .getting-started li form, .getting-started li ul li {
	font-size: 80%;
	color: #555555;
}

.getting-started li ul {
	padding-left:5pt
}

.getting-started li ul li {
	margin-bottom:0
}

.example {
	width: 630px;
	padding: 10px;
	background: #F9F9F9;
	border: 1px solid #93BDD5;
	border-radius: 10px;
	-moz-border-radius: 10px;
	-webkit-border-radius: 10px;
}

.seasideExample {
	background-color: #FBFFFA;
	border: 1px solid #93BDD5;
	margin: 1em;
	padding: 1em;
}

pre.codeSample {
	margin: 2em;
}

form.config input.checkbox { margin-right: 1em; }
form.config label { vertical-align: top; }
.container .buttons { text-align: center; margin-top: 2em; }
.container .buttons a { margin: 0 1em; }

/* jQuery override */
.ui-widget-overlay {
background:black;
opacity:0.6;
}

'! !

WAPainter subclass: #WAWelcomeUrlDialog
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Welcome'!

!WAWelcomeUrlDialog class methodsFor: 'urls' stamp: 'jf 5/24/2010 01:19'!
clearServerUrl
	WAAdmin defaultDispatcher
		serverProtocol: nil;
		serverHostname: nil;
		serverPort: nil;
		serverPath: nil! !

!WAWelcomeUrlDialog class methodsFor: 'urls' stamp: 'jf 5/24/2010 01:18'!
serverUrl
	| dispatcher |
	dispatcher := WAAdmin defaultDispatcher.
	(dispatcher serverProtocol isNil and: [ dispatcher serverHostname isNil and: [
		dispatcher serverPort isNil and: [ dispatcher serverPath isNil ] ] ])
			ifTrue: [ ^ nil ].
	^ dispatcher url! !

!WAWelcomeUrlDialog class methodsFor: 'urls' stamp: 'jf 5/24/2010 01:18'!
serverUrl: aUrl
	WAAdmin defaultDispatcher
		serverProtocol: aUrl scheme;
		serverHostname: aUrl host;
		serverPort: aUrl port;
		serverPath: aUrl pathString! !

!WAWelcomeUrlDialog methodsFor: 'rendering' stamp: 'jf 5/24/2010 01:20'!
renderContentOn: html
	| url input |
	html form
		onSubmit: (html javascript return: false);
		with: [ 
			(input := html textInput)
				value: self serverUrl greaseString;
				callback: [ :urlString | url := WAUrl absolute: urlString ].
			self serverUrl isNil ifTrue: [ 
				"Setup a sample string"
				input
					value: 'http://localhost:8080/';
					class: 'sampleValue';
					script:
						(html jQuery this onFocus:
							((html jQuery this)
								value: '';
								removeClass: 'sampleValue';
								unbind: 'focus')) ].
			html button
				bePush;
				onClick:
					(((html jQuery: #confirm) load)
						html: '';
						serializeForm;
						html: [ :r | self renderTryingUrl: url on: r ]);
				with: 'Test' ].
	html div id: 'confirm'! !

!WAWelcomeUrlDialog methodsFor: 'rendering' stamp: 'jf 5/24/2010 01:04'!
renderSuccessUrl: url on: html
	html paragraph: [ 
		html text: 'Success!! '.
		html button
			bePush;
			onClick:
				((html jQuery ajax)
					callback: [ self serverUrl: url ];
					onComplete: html javascript refresh);
		with: 'Update Configuration' ]! !

!WAWelcomeUrlDialog methodsFor: 'rendering' stamp: 'jf 5/24/2010 01:06'!
renderTryingUrl: url on: html
	| testUrl |
	testUrl := url copy addAllToPath: (WAAdmin defaultDispatcher url relativeTo: self requestContext handler url).
	html paragraph: 'Trying ' , testUrl greaseString , ' ...'.
	html script:
		((html jQuery ajax)
			script: [ :s | 
				s <<
					(s jQuery: '#confirm')
						append: [ :r |  self renderSuccessUrl: url on: r ] ];
						optionAt: 'url' put: testUrl;
						yourself)! !

!WAWelcomeUrlDialog methodsFor: 'private' stamp: 'jf 5/24/2010 01:18'!
serverUrl
	^ self class serverUrl! !

!WAWelcomeUrlDialog methodsFor: 'private' stamp: 'jf 5/24/2010 01:19'!
serverUrl: aUrl
	self class serverUrl: aUrl! !

WAComponent subclass: #WAWelcome
	instanceVariableNames: 'component'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Welcome'!

!WAWelcome commentStamp: '<historical>' prior: 0!
An short introduction to Seaside!

!WAWelcome class methodsFor: 'accessing' stamp: 'NickAger 6/16/2010 02:22'!
description
	^ 'An short introduction to Seaside'! !

!WAWelcome class methodsFor: 'initialization' stamp: 'NickAger 8/3/2010 16:29'!
initialize
	| application |
	application := WAAdmin register: self asApplicationAt: 'welcome'.
	WAAdmin defaultDispatcher defaultName: 'welcome'.
	application
		addLibrary: JQDeploymentLibrary;
		addLibrary: JQUiDeploymentLibrary;
		addLibrary: JQUiLightnessTheme;
		preferenceAt: #scriptGeneratorClass put: JQScriptGenerator.! !

!WAWelcome methodsFor: 'hooks' stamp: 'jf 6/16/2010 10:11'!
children
	^ Array with: self component! !

!WAWelcome methodsFor: 'accessing' stamp: 'NickAger 6/16/2010 01:40'!
component
	^ component ifNil: [ component := WAWelcomeGettingStarted new ]
! !

!WAWelcome methodsFor: 'rendering' stamp: 'jf 6/23/2010 18:26'!
renderContentOn: html
	html div
		class: 'container';
		with: [
			html div
				class: 'sidebar';
				with: [ self renderSideBarOn: html ].
			html div
				class: 'content';
				with: [ self renderMainContentOn: html ].
			html div class: 'clear' ]! !

!WAWelcome methodsFor: 'rendering' stamp: 'jf 6/16/2010 09:46'!
renderHeadingOn: html
	html div
		class: 'header';
		with: [
			html heading
				level1;
				class: 'welcome';
				with: self title.
			
			html heading
				level2;
				class: 'congrats';
				with: 'Congratulations, you have a working Seaside environment.' ]
! !

!WAWelcome methodsFor: 'rendering' stamp: 'jf 6/16/2010 10:11'!
renderMainContentOn: html
	self renderHeadingOn: html.
	html div
		class: 'getting-started';
		with: self component
! !

!WAWelcome methodsFor: 'rendering' stamp: 'jf 6/23/2010 20:00'!
renderSideBarDivingInOn: html
	html heading
		level: 3; 
		with: 'Diving In'.
		
	html unorderedList: [
		html listItem: [
			html anchor
				callback: [ self component show: WAWelcomeBrowse new ];
				with: 'Browse'.
			html text: ' the applications installed in your image.' ].
		html listItem: [ 
			html anchor
				callback: [ self component show: WAWelcomeConfigure new ];
				with: 'Configure'.
			html text: ' your Seaside development environment.' ].
		html listItem: [
			html text: 'Check out examples of Seaside''s new '.
			html anchor
				url: '/javascript/jquery';
				with: 'JQuery'.
			html text: ' and '.
			html anchor
				url: '/javascript/jquery-ui';
				with: 'JQuery UI'.
			html text: ' integration.' ] ]! !

!WAWelcome methodsFor: 'rendering' stamp: 'lr 9/12/2010 11:31'!
renderSideBarJoinTheCommunityOn: html
	html heading
		level: 3; 
		with: 'Join the community'.
		
	html unorderedList: [
		html listItem: [
			html text: 'Join the '.
			html anchor
				url: 'http://lists.squeakfoundation.org/cgi-bin/mailman/listinfo/seaside';
				with: 'mailing list'.
			html text: ' to ask questions and get help.' ] ].

	html form
		action: 'http://www.google.com/search';
		get;
		with: [
			html hiddenInput
				value: 'site:lists.squeakfoundation.org/pipermail/seaside/';
				name: 'q'.
			html textInput
				name: 'q'.
			html submitButton: 'Search'.
			html text: ' the mailing list' ]
! !

!WAWelcome methodsFor: 'rendering' stamp: 'lr 9/12/2010 11:30'!
renderSideBarOn: html
	html space.
	html form
		action: 'http://www.google.com/search';
		get;
		with: [
			html hiddenInput
				value: 'site:seaside.st';
				name: 'q'.

			html textInput
				name: 'q'.
			html submitButton: 'Search'.
			html text: ' the Seaside site'.
		].
	
	self renderSideBarJoinTheCommunityOn: html.
	self renderSideBarDivingInOn: html.
! !

!WAWelcome methodsFor: 'accessing' stamp: 'NickAger 6/15/2010 13:46'!
title
	^ 'Welcome to Seaside'! !

!WAWelcome methodsFor: 'updating' stamp: 'NickAger 6/16/2010 03:10'!
updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.
	
	anHtmlRoot title: self title.
	anHtmlRoot link beShortcutIcon; url: WAToolFiles / #faviconIco.
	WAWelcomeFiles default updateRoot: anHtmlRoot
! !

WAComponent subclass: #WAWelcomeAuthorNamePrompter
	instanceVariableNames: 'authorName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Welcome'!

!WAWelcomeAuthorNamePrompter methodsFor: 'accessing' stamp: 'NickAger 11/6/2010 17:49'!
authorName
	^ authorName ifNil: [ authorName := 'FirstnameLastname' ]! !

!WAWelcomeAuthorNamePrompter methodsFor: 'accessing' stamp: 'NickAger 11/6/2010 17:47'!
authorName: anAuthorName
	authorName := anAuthorName ! !

!WAWelcomeAuthorNamePrompter methodsFor: 'private' stamp: 'NickAger 11/6/2010 18:56'!
handleAuthorNameSubmission
	| checkedName |
	"AuthorName appears to prefer no accented characters so a simple select block with 'char isLetter' is not sufficent"
	self authorName: (self authorName select: [ :char | 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz' includes: char ]).
	
	self authorName ifEmpty: [ self authorName: nil. ^ self ].
	
	GRPlatform current seasideSetAuthorName: self authorName.
	self answer! !

!WAWelcomeAuthorNamePrompter methodsFor: 'rendering' stamp: 'NickAger 11/6/2010 18:37'!
renderContentOn: html
	html form: [
		html text: 'You are about to create your first component in this Smalltalk image, please enter your name to associate it with your code:'.
		html textInput
			on: #authorName of: self.
		html submitButton
			text: 'OK';
			callback: [self handleAuthorNameSubmission]
	]! !

WAComponent subclass: #WAWelcomeBrowse
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Welcome'!

!WAWelcomeBrowse methodsFor: 'private' stamp: 'NickAger 6/16/2010 07:10'!
redirectToBrowse
	self requestContext responseGenerator redirectTo: '/browse'; respond
! !

!WAWelcomeBrowse methodsFor: 'rendering' stamp: 'obi 7/18/2010 16:50'!
renderContentOn: html
	html heading
		level1
		with: 'Browse installed applications'.
	html anchor
			class: 'goback';
			callback: [ self answer ];
			with: '[ go back ]'.
			
	html paragraph: [
		html text: 'Would you like to set '.
		html anchor
			url: '/browse';
			with: 'Browse'.
		html text: ' to be the default application when you visit this site? This will disable this welcome screen (though you can always find it later at '.
		html anchor
			url: self application url;
			with: self application url.
		html text: ').' ].
		
		html div
			class: 'buttons';
			with: [
			html anchor
				callback: [ self setBrowseAsDefault ];
				script: (html jQuery this button
					primaryIcon: 'ui-icon-pin-s');
				title: 'Yes, change the default';
				with: 'Yes'.	
			html anchor
				callback: [ self redirectToBrowse ];
				script: (html jQuery this button
					primaryIcon: 'ui-icon-folder-open');
				title: 'No, just Browse for now';
				with: 'No'.
			html anchor
				callback: [ self answer ];
				script: (html jQuery this button
					primaryIcon: 'ui-icon-arrowreturnthick-1-w');
				title: 'Go back';
				with: 'Back' ]! !

!WAWelcomeBrowse methodsFor: 'private' stamp: 'NickAger 6/16/2010 02:58'!
setBrowseAsDefault
	WAAdmin defaultDispatcher defaultName: 'browse'.
	self redirectToBrowse 
	
! !

WAComponent subclass: #WAWelcomeComponentConfirmation
	instanceVariableNames: 'componentName component'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Welcome'!

!WAWelcomeComponentConfirmation class methodsFor: 'instance creation' stamp: 'NickAger 6/16/2010 00:12'!
component: component named: componentName
	^ self new
		component: component;
		componentName: componentName;
		yourself! !

!WAWelcomeComponentConfirmation methodsFor: 'hooks' stamp: 'NickAger 6/16/2010 01:45'!
children
	^ Array with: self component! !

!WAWelcomeComponentConfirmation methodsFor: 'accessing' stamp: 'NickAger 6/16/2010 00:08'!
component
	^ component! !

!WAWelcomeComponentConfirmation methodsFor: 'accessing' stamp: 'NickAger 6/16/2010 00:08'!
component: anObject
	component := anObject! !

!WAWelcomeComponentConfirmation methodsFor: 'accessing' stamp: 'NickAger 6/15/2010 20:19'!
componentName
	^ componentName! !

!WAWelcomeComponentConfirmation methodsFor: 'accessing' stamp: 'NickAger 6/15/2010 20:19'!
componentName: anObject
	componentName := anObject! !

!WAWelcomeComponentConfirmation methodsFor: 'rendering' stamp: 'NickAger 11/6/2010 18:40'!
renderContentOn: html
	html paragraph: [
		html text: 'You can see your component in action here: '.
		html anchor
			target: '_blank';
			url: '/', self componentName;
			with: '/', self componentName ].
		
	html paragraph: [
		html text: 'Now go find the class ';
			code: self componentName;
			text: ' in your Smalltalk image. First, try changing the displayed text by changing the ';
			code: '#renderContentOn:';
			text: ' method. Then you can experiment further based on what you''ve seen in the examples and what you read in the '.
		html anchor
				url: 'http://book.seaside.st/';
				with: 'documentation.' ].
		
	html paragraph: [
		html text: 'Want to '.
		html anchor
			callback: [ self answer ];
			with: 'create another component'.
		html text: '?' ]! !

WAComponent subclass: #WAWelcomeComponentNamePrompter
	instanceVariableNames: 'componentName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Welcome'!

!WAWelcomeComponentNamePrompter methodsFor: 'accessing' stamp: 'NickAger 6/15/2010 20:10'!
componentName
	^ componentName ifNil: [ componentName := 'MyFirstComponent' ]! !

!WAWelcomeComponentNamePrompter methodsFor: 'accessing' stamp: 'NickAger 6/15/2010 20:11'!
componentName: anObject
	componentName := anObject! !

!WAWelcomeComponentNamePrompter methodsFor: 'rendering' stamp: 'NickAger 6/15/2010 23:29'!
renderContentOn: html
	html form: [
		html text: 'Name your component: '.
		html textInput
			on: #componentName of: self.
		html submitButton
			text: 'Create';
			callback: [self answer: self componentName capitalized asSymbol]
	]! !

WAComponent subclass: #WAWelcomeConfigure
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Welcome'!

!WAWelcomeConfigure methodsFor: 'private' stamp: 'lr 6/13/2010 17:41'!
clearServerUrl
	WAWelcomeUrlDialog clearServerUrl! !

!WAWelcomeConfigure methodsFor: 'actions' stamp: 'lr 6/13/2010 17:23'!
disableErrorWalkbacks
	WAAdmin applicationExceptionHandlingDefaults at: #exceptionHandler put: WAHtmlErrorHandler! !

!WAWelcomeConfigure methodsFor: 'actions' stamp: 'lr 6/13/2010 17:22'!
enableErrorWalkbacks
	WAAdmin applicationExceptionHandlingDefaults at: #exceptionHandler put: WAWalkbackErrorHandler! !

!WAWelcomeConfigure methodsFor: 'testing' stamp: 'lr 6/13/2010 17:22'!
errorWalkbacksEnabled
	^ (WAAdmin applicationExceptionHandlingDefaults at: #exceptionHandler) = WAWalkbackErrorHandler! !

!WAWelcomeConfigure methodsFor: 'rendering-parts' stamp: 'obi 7/18/2010 16:53'!
renderButtonsOn: html
	html div class: 'buttons'; with: [
		html anchor
			url: '/config';
			script: (html jQuery this button
				primaryIcon: 'ui-icon-gear');
			with: 'Advanced Configuration'.
		html anchor
			callback: [ self answer ];
			script: (html jQuery this button
				primaryIcon: 'ui-icon-arrowreturnthick-1-w');
			title: 'Go back';
			with: 'Back' ]! !

!WAWelcomeConfigure methodsFor: 'rendering' stamp: 'lr 8/22/2010 15:25'!
renderContentOn: html
	html form class: 'config'; with: [ 
		html heading: 'Basic Configuration'.
		html anchor
			class: 'goback';
			callback: [ self answer ];
			with: '[ go back ]'.
		self renderDescriptionOn: html.
		self renderToolsOn: html.
		self renderWalkbacksOn: html.
		self renderServerUrlOn: html.
		self renderButtonsOn: html ]! !

!WAWelcomeConfigure methodsFor: 'rendering-parts' stamp: 'jf 6/23/2010 19:45'!
renderDescriptionOn: html
	html paragraph: [
		html text: 'Here are a few common settings you might want to change. Once you''re ready for more, you can jump over to the '.
		html anchor
			url: '/config';
			with: 'advanced configuration tool'.
		html text: '.' ]! !

!WAWelcomeConfigure methodsFor: 'rendering-parts' stamp: 'jf 6/16/2010 10:44'!
renderServerUrlOn: html
	| id |
	html div
		id: (id := html nextId);
		class: 'dialog';
	      script: (html jQuery new dialog
			html: WAWelcomeUrlDialog new;
			title: 'Configure server URL';
			resizable: false;
			modal: true).
	html paragraph: [
		html text: 'Public server URL: '; text: self serverUrl; text: ' [ '.
		html anchor
			url: '#';
			onClick: ((html jQuery id: id) dialog open return: false);
			with: 'set'.
		self serverUrl isNil ifFalse: [
			html text: ' / '.
			html anchor
				callback: [ self clearServerUrl ];
				with: 'clear' ].
		html text: ' ]' ]! !

!WAWelcomeConfigure methodsFor: 'rendering-parts' stamp: 'jf 6/16/2010 10:30'!
renderToolsOn: html
	html paragraph: [
		html checkbox
			id: html nextId;
			value: WAAdmin developmentToolsEnabled;
			onTrue: [ WAAdmin enableDevelopmentTools ]
			onFalse: [ WAAdmin disableDevelopmentTools ];
			onChange: (html jQuery ajax serializeForm).
		html label
			for: html lastId;
			with: 'Show development toolbar' ]! !

!WAWelcomeConfigure methodsFor: 'rendering-parts' stamp: 'jf 6/16/2010 10:31'!
renderWalkbacksOn: html
	html paragraph: [
		html checkbox
			id: html nextId;
			value: self errorWalkbacksEnabled;
			onTrue: [ self enableErrorWalkbacks ]
			onFalse: [ self disableErrorWalkbacks ];
			onChange: (html jQuery ajax serializeForm).
		html label
			for: html lastId;
			with: 'Allow debugging of errors' ]! !

!WAWelcomeConfigure methodsFor: 'private' stamp: 'lr 6/13/2010 17:41'!
serverUrl
	^ WAWelcomeUrlDialog serverUrl! !

WAComponent subclass: #WAWelcomeExample
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Welcome'!

!WAWelcomeExample methodsFor: 'rendering' stamp: 'obi 7/18/2010 16:51'!
renderContentOn: html
	html heading level1 with: 'Example: ', self title.
	html anchor
		class: 'goback';
		callback: [ self answer ];
		with: '[ go back ]'.
	self renderExampleOn: html.
		
	html div
		class: 'buttons';
		with: [
			html anchor
				callback: [ self answer ];
				script: (html jQuery this button
					primaryIcon: 'ui-icon-arrowreturnthick-1-w');
				title: 'Go back';
				with: 'Back' ]! !

!WAWelcomeExample methodsFor: 'rendering' stamp: 'jf 6/16/2010 09:56'!
renderExampleOn: html
	self subclassResponsibility! !

!WAWelcomeExample methodsFor: 'private' stamp: 'jf 6/16/2010 09:59'!
title
	self subclassResponsibility! !

WAWelcomeExample subclass: #WAWelcomeExampleCounter
	instanceVariableNames: 'counter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Welcome'!

!WAWelcomeExampleCounter methodsFor: 'hooks' stamp: 'NickAger 6/16/2010 00:18'!
children
	^ Array with: self counter! !

!WAWelcomeExampleCounter methodsFor: 'accessing' stamp: 'NickAger 6/16/2010 00:18'!
counter
	^ counter ifNil: [counter := WACounter new]! !

!WAWelcomeExampleCounter methodsFor: 'rendering' stamp: 'jf 6/16/2010 10:00'!
renderExampleOn: html
	html paragraph: 'The counter is an example of a very simple Seaside component. It increments and decrements a number by clicking on a link. Test the example below by clicking on the "++" and "--" links:'.

	html div class: #seasideExample; with: counter.

	html paragraph: [		
		html text: 'This application is coded in two short methods. It is implemented in class ';	code: 'WACounter';  text: ', a subclass of '; code: 'WAComponent'
	].

	html paragraph: 'The first method initializes the counter to 0:'.

	self renderInitializeCodeOn: html.
	
	html paragraph: 'The second method generates the output and assigns the actions to the anchors (links) which update the current value.'.
	
	self renderRenderContentOnCodeOn: html.
	
! !

!WAWelcomeExampleCounter methodsFor: 'rendering' stamp: 'NickAger 6/16/2010 00:21'!
renderInitializeCodeOn: html
	html preformatted class: #codeSample; with: [
		html span class: #patternUnary; with: 'initialize'. html break.
		html span class: #super; with:'    super'. html text:' initialize.'. html break.
		html span class: #instanceVar; with:'    count'. html text: ' := '. html span class: #number; with: '0'		
		].
! !

!WAWelcomeExampleCounter methodsFor: 'rendering' stamp: 'NickAger 6/16/2010 00:21'!
renderRenderContentOnCodeOn: html
	html preformatted class: #codeSample; with: [
		html span class: #patternKeyword; with: 'renderContentOn: '. html span class: #patternArg; with: 'html'. html break.
    		html span class: #receiver; with: '    html'. html text: ' heading: '. html span class: #instanceVar; with: 'count.'. html break.
		html span class: #receiver; with: '    html'. html text: ' anchor'. html break.
		html text: '        callback: [ '. html span class: #instanceVar; with: 'count '. html text: ':= '. html span class: #instanceVar; with: 'count'. html text: ' + '. html span class: #number; with: '1'. html text: ' ];'. html break.
		html text: '        with: '. html span class: #string; with: '''++'''. html text: '.'. html break.
		html span class: #receiver; with: '    html'. html text: ' space.'. html break.
		html span class: #receiver; with: '    html'. html text: ' anchor'. html break.
		html text: '        callback: [ '. html span class: #instanceVar; with: 'count '. html text: ':= '. html span class: #instanceVar; with: 'count'. html text: ' - '. html span class: #number; with: '1'. html text: ' ];'. html break.
		html text: '        with: '. html span class: #string; with: '''--'''. html text: '.'.
		]! !

!WAWelcomeExampleCounter methodsFor: 'private' stamp: 'jf 6/16/2010 10:00'!
title
	^ 'Counter'! !

WAWelcomeExample subclass: #WAWelcomeExampleFlow
	instanceVariableNames: 'taskExample'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Welcome'!

!WAWelcomeExampleFlow methodsFor: 'hooks' stamp: 'NickAger 6/16/2010 00:53'!
children
	^ Array with: self taskExample! !

!WAWelcomeExampleFlow methodsFor: 'rendering' stamp: 'NickAger 6/16/2010 00:55'!
renderChooseCheeseCodeOn: html
	html preformatted class: #codeSample; with: [
		html span class: #patternUnary; with: 'chooseCheese'. html break.
		html span class: #instanceVar; with: '    cheese'. html text: ' := '. html span class: #self; with: 'self'. html break.
		html text: '        chooseFrom: '. html span class: #symbol; with: '#'. html text: '( '. html span class: #string; with: '''Greyerzer'' ''Tilsiter'' ''Sbrinz'''. html text: ' )'. html break.
		html text:'        caption: '. html span class: #string; with: '''What''''s your favorite cheese?'''. html text: '.'. html break.
		html span class: #instanceVar; with: '    cheese'. html text: ' isNil ifTrue: [ '. html span class: #self; with: 'self'. html text:' chooseCheese ]'
		]
! !

!WAWelcomeExampleFlow methodsFor: 'rendering' stamp: 'NickAger 6/16/2010 00:55'!
renderConfirmCheeseCodeOn: html
	html preformatted class: #codeSample; with: [
		html span class: #patternUnary; with: 'confirmCheese'. html break.
		html text: '    ^ '. html span class: #self; with: 'self'. html text: ' confirm: '. html span class: #string; with: '''Is '''. html text:', '. html span class: #instanceVar; with: 'cheese'. html text: ','. html span class: #string; with: ''' your favorite cheese?'''. html break
		]
! !

!WAWelcomeExampleFlow methodsFor: 'rendering' stamp: 'jf 6/16/2010 10:20'!
renderExampleOn: html
	html paragraph: 'Complex, multi-page workflows can be expressed in Seaside with a single method. Unlike many web frameworks  which require a separate handler for each page or request, Seaside models an entire user session as a continuous piece of code, with natural, linear control flow.'.

	html div class: #seasideExample; with: taskExample.
		
	html paragraph: [		
		html text: 'This example subclasses '; code: 'WATask'; text: ' and implements the hook method '; code: '#go'.
		html text: '. We store the user''s choice in an instance variable named '; code: 'cheese.'.
	].

	self renderGoCodeOn: html.
	
	html paragraph: [
		html text: 'To allow the user to choose from a list of famous Swiss cheeses, we use the convenience method '; code: '#chooseFrom:caption:'; text: ' which returns the chosen element from a collection or '; code: 'nil'; text: ' if the user cancels the dialog. If '; code: 'nil'; text: ' is returned, we simply ask again.'
		].
	
	self renderChooseCheeseCodeOn: html.
	
	html paragraph: [
		html text: 'Then we ask the user to confirm their choice. The '; code: '#confirm:'; text: ' method answers a '; code: 'boolean:'
		].
	
	self renderConfirmCheeseCodeOn: html.
	
	html paragraph: [
		html text: 'Finally we display the user''s choice using '; code: '#inform:.'.
		].
	
	self renderInformCheeseCodeOn: html.
	
	html paragraph: 'As simple as that. And yes, the browser''s Back button still works.'
		
! !

!WAWelcomeExampleFlow methodsFor: 'rendering' stamp: 'NickAger 6/16/2010 00:55'!
renderGoCodeOn: html
	html preformatted class: #codeSample; with: [
		html span class: #patternUnary; with: 'go'. html break.
		html text: '    [ '. html span class: #self; with: 'self'. html text: ' chooseCheese.'. html break.
		html text: '      '. html span class: #self; with: 'self'. html text: ' confirmCheese'. html text: ' ] whileFalse.'. html break.
		html text: '    '. html span class: #self; with: 'self'. html text: ' informCheese.'
	]! !

!WAWelcomeExampleFlow methodsFor: 'rendering' stamp: 'NickAger 6/16/2010 00:55'!
renderInformCheeseCodeOn: html
	html preformatted class: #codeSample; with: [
		html span class: #patternUnary; with: 'informCheese'. html break.
		html span class: #self; with: '    self'. html text: ' inform: '. html span class: #string; with: '''Your favorite is '''. html text:', '. html span class: #instanceVar; with: 'cheese'. html text: ','. html span class: #string; with: '''.'''. html break
		]! !

!WAWelcomeExampleFlow methodsFor: 'accessing' stamp: 'NickAger 6/16/2010 00:53'!
taskExample
	^ taskExample ifNil: [ taskExample := WAFlowConvenienceFunctionalTest new ]! !

!WAWelcomeExampleFlow methodsFor: 'private' stamp: 'jf 6/16/2010 10:00'!
title
	^ 'Task'! !

WAWelcomeExample subclass: #WAWelcomeExampleMultiCounter
	instanceVariableNames: 'multicounter'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Welcome'!

!WAWelcomeExampleMultiCounter methodsFor: 'hooks' stamp: 'NickAger 6/16/2010 00:51'!
children
	^ Array with: self multicounter! !

!WAWelcomeExampleMultiCounter methodsFor: 'accessing' stamp: 'NickAger 6/16/2010 00:47'!
multicounter
	^ multicounter ifNil: [ multicounter := multicounter := WAMultiCounter new ]! !

!WAWelcomeExampleMultiCounter methodsFor: 'rendering' stamp: 'NickAger 6/16/2010 00:48'!
renderChildrenCodeOn: html
	html preformatted class: #codeSample; with: [
		html span class: #patternUnary; with: 'children'. html break.
		html text: '    ^ '. html span class: #instanceVar; with: 'counters'
		]! !

!WAWelcomeExampleMultiCounter methodsFor: 'rendering' stamp: 'jf 6/16/2010 10:01'!
renderExampleOn: html
	html paragraph: [
		html text: 'Multicounter is a simple extension to the '.
		html anchor callback: [self show: WAWelcomeExampleCounter new]; with: 'Counter'.
		html text: ' application. It displays several instances of the same '.
		html anchor callback: [self show: WAWelcomeExampleCounter new]; with: 'Counter'.
		html text: ' component:'
		].
	
	html div class: #seasideExample; with: multicounter.
	
	html paragraph: [
		html text: 'This component is implemented in a few lines of code. The code is contained in the class '; code: 'WAMultiCounter'; text: ', a subclass of '; code: 'WAComponent. '
	].

	html paragraph: 'The first method is used to initialize the component, in this case we instantiate 5 counters:'.
	 
	self renderInitializeCodeOn: html.
	
	html paragraph: 'We then tell Seaside which child components we intend to display. In our case this is just the collection of counter instances:'.
	
	self renderChildrenCodeOn: html.
	
	html paragraph: 'Finally we display each of the components separated by a horizontal rule:'.
	
	self renderRenderContentsOnCodeOn: html
	
! !

!WAWelcomeExampleMultiCounter methodsFor: 'rendering' stamp: 'NickAger 6/16/2010 00:48'!
renderInitializeCodeOn: html
	html preformatted class: #codeSample; with: [
		html span class: #patternUnary; with: 'initialize'. html break.
		html span class: #super; with:'    super'. html text:' initialize.'. html break.
    		html span class: #instanceVar; with:'    counters'. html text: ' := ('. html span class: #number; with: '1'. html text:' to: '. html span class: #number; with: '5'. html text: ')'. html break.
		html text: '         collect: [ '. html span class: #blockArg; with: ':each'. html text: ' | '. html span class: #class; with: 'WACounter'. html text:' new ]'
		]! !

!WAWelcomeExampleMultiCounter methodsFor: 'rendering' stamp: 'NickAger 6/16/2010 00:48'!
renderRenderContentsOnCodeOn: html
	html preformatted class: #codeSample; with: [
		html span class: #patternKeyword; with: 'renderContentOn: '. html span class: #patternArg; with: 'html'. html break.
    		html span class: #instanceVar; with: '    counters'. html break.
		html text: '        do: [ '. html span class: #blockArg; with: ':each'. html text: ' | '. html span class: #receiver; with: 'html'.  html text: ' render: '. html span class: #patternArg; with:'each'. html text: ' ]'. html break.
		html text: '         separatedBy: [ '.  html span class: #receiver; with: 'html'. html text: ' horizontalRule ]'
		]
! !

!WAWelcomeExampleMultiCounter methodsFor: 'private' stamp: 'jf 6/16/2010 10:01'!
title
	^ 'Multi-Counter'! !

WAComponent subclass: #WAWelcomeGettingStarted
	instanceVariableNames: 'componentCreator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside-Welcome'!

!WAWelcomeGettingStarted methodsFor: 'hooks' stamp: 'NickAger 6/16/2010 01:42'!
children 
	^ Array with: self componentCreator ! !

!WAWelcomeGettingStarted methodsFor: 'accessing' stamp: 'NickAger 6/16/2010 01:32'!
componentCreator
	^ componentCreator ifNil: [componentCreator := WAWelcomeComponentCreator new]
! !

!WAWelcomeGettingStarted methodsFor: 'rendering' stamp: 'jf 6/16/2010 11:25'!
renderContentOn: html
	html heading
		level1;
		with: 'Getting started'.
			
	html heading
		level2
		with: 'Test the water with the steps below:'.
				
	html orderedList: [
		html listItem: [ self renderExamplesStepOn: html ].
		html listItem: [ self renderFirstComponentStepOn: html ].
		html listItem: [ self renderDocumentationStepOn: html ] ]
! !

!WAWelcomeGettingStarted methodsFor: 'rendering-steps' stamp: 'lr 7/14/2010 09:52'!
renderDocumentationStepOn: html
	html heading
		level3;
		with: 'Browse the documentation'.
		
	html unorderedList: [ 
		html listItem: [
			html text: 'The  '.
			html anchor
				url: 'http://book.seaside.st/';
				with: 'Seaside Book'.
			html text: ' will teach you all you need to know about Seaside and how to build killer web applications.' ].
		html listItem: [ 
			html text: 'The '.
			html anchor
				url: 'http://www.swa.hpi.uni-potsdam.de/seaside/tutorial';
				with: 'Seaside Tutorial'.
			html text: ' has 12 chapters and introduces a sample application to explain the main features of Seaside.' ] ].

! !

!WAWelcomeGettingStarted methodsFor: 'rendering-steps' stamp: 'lr 7/14/2010 09:52'!
renderExamplesStepOn: html
	html heading
		level3;
		with: 'Try out some examples'.
		
	html
		unorderedList: [ 
			html listItem: [ 
				html anchor
					callback: [ self show: WAWelcomeExampleCounter new ];
					with: 'Counter'.
				html text: ', a simple Seaside component.' ].
			html listItem: [
				html anchor
					callback: [ self show: WAWelcomeExampleMultiCounter new ];
					with: 'Multi-Counter'.
				html text: ', showing how Seaside components can be re-used.' ].
			html listItem: [ 
				html anchor
					callback: [ self show: WAWelcomeExampleFlow new ];
					with: 'Task'.
				html text: ', illustrating Seaside''s innovative approach to application control flow.' ] ]! !

!WAWelcomeGettingStarted methodsFor: 'rendering-steps' stamp: 'lr 7/14/2010 09:52'!
renderFirstComponentStepOn: html
	html heading
		level3;
		with: 'Create your first component'.
		
	html render: self componentCreator
! !
WAWelcome initialize!
